frontend http-in
    bind *:80
{% if external_url_ssl and external_ssl_source != '' %}
    bind *:443 ssl crt /usr/local/etc/haproxy/{{ external_host }}.pem

    http-request redirect scheme https unless { ssl_fc }
    http-request set-header X-Forwarded-Proto https if { ssl_fc }
    http-request set-header X-Forwarded-Ssl on if { ssl_fc }
{% endif %}

{% if 'monitor' in groups %}
    acl grafana path_beg -i /-/grafana
    use_backend grafana if grafana
{% endif %}

    default_backend gitlab-rails

frontend gitlab-ssh-in
    bind *:{{ gitlab_shell_ssh_port }}
    mode tcp
    option tcplog
    option clitcpka

    default_backend gitlab-rails-ssh

{% if container_registry_enable %}
frontend gitlab-registry-in
    bind *:{{ container_registry_port }} ssl crt /usr/local/etc/haproxy/{{ external_host }}.pem
    option forwardfor
    http-request set-header X-Forwarded-Proto https if { ssl_fc }

    default_backend gitlab-registry
{% endif %}

backend gitlab-rails
    option httpchk GET /-/readiness
    option forwardfor

{% for ip in gitlab_rails_int_addrs %}
    server gitlab-rails{{loop.index}} {{ ip }}:80 check inter 3s fall 1
{% endfor %}

backend gitlab-rails-ssh
    mode tcp
    option tcp-check
    option httpchk GET /-/readiness
    option srvtcpka

{% for ip in gitlab_rails_int_addrs %}
    server gitlab-rails{{loop.index}} {{ ip }}:22 track gitlab-rails/gitlab-rails{{loop.index}}
{% endfor %}

{% if 'monitor' in groups %}
backend grafana
    option httpchk GET /-/grafana/api/health
    option forwardfor

    server grafana {{ monitor_int_addr }}:80 check
{% endif %}

{% if container_registry_enable %}
backend gitlab-registry
    option forwardfor

{% for ip in gitlab_rails_int_addrs %}
    server gitlab-rails{{loop.index}} {{ ip }}:{{ container_registry_port }}
{% endfor %}
{% endif %}
